unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CommCtrl;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    ListBox1: TListBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    DskList : hWnd;
  public
    { Public declarations }
  end;

  PInfo = ^TInfo;
  TInfo = packed record
    Text: array[0..255] of Char;
    Item: TLVItem;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  NumItens : Integer;
  Info : PInfo;
  i : Integer;
  Handle : THandle;
begin
  DskList := FindWindowEx(GetDesktopWindow,0,'Progman','Program Manager');
  DskList := FindWindowEx(DskList,0,'ShellDLL_DefView',nil);
  DskList := FindWindowEx(DskList,0,'SysListView32',nil);
  NumItens := ListView_GetItemCount(DskList);
  Label1.Caption := 'Nmero de itens - '+IntToStr(NumItens);
  Handle := CreateFileMapping($FFFFFFFF, nil, PAGE_READWRITE, 0,
        Sizeof(TInfo), '');
  if Handle = 0 then
    Abort;
  Info := MapViewOfFile(Handle, FILE_MAP_WRITE, 0, 0, Sizeof(TInfo));
  try
    with Info^ do begin
      Item.pszText := Text;
      Item.cchTextMax := 255;
      Item.mask := LVIF_TEXT;
      for i := 0 to NumItens - 1 do begin
        Item.iItem := i;
        Item.iSubItem := 0;
        ListView_GetItem(DskList, Item);
        Listbox1.Items.Add(String(Item.pszText));
      end;
    end;
  finally
    UnmapViewOfFile(Info);
  end;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  ListView_SetTextBkColor(DskList, $ffffffff);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ListView_SetTextBkColor(DskList, clNavy);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ListView_Arrange(DskList,LVA_ALIGNTOP);
end;

end.
